<?php
/*------------------------------------------------------------------------
# shaper_simplicity_ii - Joomla Template by JoomShaper.com
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# copyright Copyright (C) 2010 - 2011 JoomShaper.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
# Websites: http://www.joomshaper.com - http://www.joomxpert.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class SPTemplateHelper{
    var $doc; 
	
	//initialize 
    public function __construct(){
		$this->doc= &JFactory::getDocument();
    }
    
	public function getParam(){
      $app       = & JFactory::getApplication();
      $strparam  	 = null;
      $strini   = JPATH_THEMES.DS.$app->getTemplate().DS.'params.ini';
      jimport('joomla.filesystem.file');
      if (JFile::exists($strini)) {
         $strparam = JFile::read($strini);
      } else {
         $strparam = null;
      }
      return new JParameter($strparam);      
	}	
	
	//convert array to object
    public function arrayToObject($array){
        $obj = new stdClass();
        if(is_array($array)){
            foreach($array as $key=>$val){
                if(!empty($key)){
                    $obj->$key = $val;
                }
            }
            return $obj;            
        }
    }
	
    //check for module
    function hasModule($position){
        if (!is_array($position)) $position = array($position);           
        if(is_array($position)){    
           $modcount=0;
           $modules=array();
           foreach($position as $key=>$val){
               if($this->doc->countModules($val)){
                 array_push($modules,$val);
                 $modcount++;
               } 
           }
            if($modcount==0){
                return false;
            }
           return $modules; 
        }
        
    }
	
    //render module
    function renderModule($pos, $grid=12){
		$activeMod= $this->hasModule($pos);

		if ($grid==4) {
			$maxMods=2;
		} elseif ($grid==8) {
			$maxMods=4;
		} else {
			$maxMods=6;
		}
		
		
		//Eliminate extra module positions
		if (count($activeMod)>$maxMods) {
			for ($i=0;$i<$maxMods;$i++) {
				$newMods[]=$activeMod[$i];
			}
		} else {
			$newMods=$activeMod;		
		}
		
		
		$max= count($newMods);
		
		$spgrid= floor($grid/count($newMods)); 
		
		if ($grid==8) {
			if ($max==3) {
				$spgridspecial=3;
			} else {
				$spgridspecial=$spgrid;
			}	
		} else {
			if ($max==5) {
				$spgridspecial=3;
			} else {
				$spgridspecial=$spgrid;
			}
		}
		
        $count=1;
 
			
        if(is_array($newMods)){
            $modules = array();
            foreach($newMods as $key=>$val){
                if($count==1){
                    $modules[$count] = array(
                    'name'=>$val,
                    'grid'=>'sp-grid-'.$spgridspecial,
                    'extra-css'=> 'alpha'
                    );  
                }
                elseif($count==$max){
                    $modules[$count] = array(
                    'name'=>$val,
                    'grid'=>'sp-grid-'.$spgridspecial,
                    'extra-css'=> 'omega'
                    );  
                } 
                else{
                    $modules[$count] = array(
                    'name'=>$val,
                    'grid'=>'sp-grid-'.$spgrid,
                    'extra-css'=> ''
                    );  
                }
                
                $count++;
            }  
            return $modules;
        }
        return false;
    }
	
	//Detect IE version
	function sp_isIe($version = false) {   
		$agent=$_SERVER['HTTP_USER_AGENT'];  
		$found = strpos($agent,'MSIE ');  
		if ($found) { 
				if ($version) {
					$ieversion = substr(substr($agent,$found+5),0,1);   
					if ($ieversion == $version) return true;
					else return false;
				} else {
					return true;
				}
				
			} else {
					return false;
			}
		if (stristr($agent, 'msie'.$ieversion)) return true;
		return false;        
	}
	
	//Mootools Version
	function mooVersion() {
		if(isset(JFactory::getApplication()->MooToolsVersion) && JFactory::getApplication()->MooToolsVersion=='1.2.4 +Compat') {
			$moover='12';
		}else {
			$moover='11';
		}	
		return $moover;
	}
	
	//get color
	function getColor() {
		$style  = isset($_COOKIE['sportive_color']) ? $_COOKIE['sportive_color'] : $this->getParam()->get('color','style1');
		if(isset($_GET['color'])) {
			setcookie('sportive_color', $_GET['color'], time() + 3600, '/'); 
			$style = $_GET['color'];
		}
		return $style;	
	}
	
	//get language direction
	function getDirection() {
		$direction  = isset($_COOKIE['sportive_direction']) ? $_COOKIE['sportive_direction'] : $this->getParam()->get('direction','ltr');
		if(isset($_GET['direction'])) {
			setcookie('sportive_direction', $_GET['direction'], time() + 3600, '/'); 
			$direction = $_GET['direction'];
		}
		return $direction;		
	}
	
	//Special position like left,right
	function specialGrid() {
		$grid=array();
		
		if ($this->doc->countModules( 'left and right' )) {
			$grid['content']="6";
		} elseif ($this->doc->countModules( 'left or right' )) {
			$grid['content']="9";
		} else {
			$grid['content']="12";		
		}
		
		return $grid;	
	}
}
