<?php
/*
# ------------------------------------------------------------------------
# Free Slide SP1 - Slideshow module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2010 JoomShaper.com. All Rights Reserved.
# @license - GNU/GPL, see LICENSE.php,
# Author: JoomShaper.com
# Websites:  http://www.joomshaper.com -  http://www.joomxpert.com
# ------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modSlideShowSP2Helper
{
		
	function getList(&$params){
		
		global $mainframe;
		
		$cparams	    =& $mainframe->getParams('com_content');

		$db			    =& JFactory::getDBO();
		$user		    =& JFactory::getUser();
		$userId		    = (int) $user->get('id');
		
		$count		    = $params->get('max_article',3); 
		$catid		    = trim( $params->get('com_categories') );
		$secid		    = trim( $params->get('com_sections') );
		$show_fp	    = $params->get('show_fp', 1);
		$aid		    = $user->get('aid', 0);
		$content_source = $params->get('content_source','com_categories');
		$ordering       = $params->get('itemsOrdering');
		$k2cid          = $params->get('k2_categories', NULL);
		$imgSource    = $params->get('imgSource', 'M');			
		$user_id        = $params->get('user_id');
		
		$contentConfig  = &JComponentHelper::getParams( 'com_content' );
		$access		    = !$contentConfig->get('shownoauth');

		$nullDate	    = $db->getNullDate();

		$date =& JFactory::getDate();
		$now = $date->toMySQL();
		$where = '';
		
		// User Filter
		switch ($user_id)
		{
			case 'by_me':
				$where .= ' AND (a.created_by = ' . (int) $userId . ' OR a.modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (a.created_by <> ' . (int) $userId . ' AND a.modified_by <> ' . (int) $userId . ')';
				break;
		}
		
		// ensure should be published
		$where .= " AND ( a.publish_up = ".$db->Quote($nullDate)." OR a.publish_up <= ".$db->Quote($now)." )";
		$where .= " AND ( a.publish_down = ".$db->Quote($nullDate)." OR a.publish_down >= ".$db->Quote($now)." )";
		
	    // ordering
		switch ($ordering) {
			case 'date' :
				$orderby = 'a.created ASC';
				break;
			case 'rdate' :
				$orderby = 'a.created DESC';
				break;
			case 'alpha' :
				$orderby = 'a.title';
				break;
			case 'ralpha' :
				$orderby = 'a.title DESC';
				break;
			case 'order' :
				$orderby = 'a.ordering';
				break;
			default :
				$orderby = 'a.id DESC';
				break;
		}
		
		// content specific stuff
        if ($content_source=='k2_categories') {
		    // start K2 specific
		    require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
		    
    		$query = "SELECT a.*, c.name as categoryname,c.id as categoryid, c.alias as categoryalias, c.params as categoryparams".
    		" FROM #__k2_items as a".
    		" LEFT JOIN #__k2_categories c ON c.id = a.catid";
	
    		$query .= " WHERE a.published = 1"
    		." AND a.access <= {$aid}"
    		." AND a.trash = 0"
    		." AND c.published = 1"
    		." AND c.access <= {$aid}"
    		." AND c.trash = 0"
    		;
	
			if (!is_null($k2cid)) {
			
				if (is_array($k2cid)) {
					$k2cids = implode($k2cid,',');	
					$ids = explode( ',', $k2cids );
				} else {
					$ids = explode( ',', $k2cid );
				}			
				
				JArrayHelper::toInteger( $ids );					
				$query .= ' AND (a.catid=' . implode( ' OR a.catid=', $ids ) . ')';
			}


    		if ($params->get('FeaturedItems')=='0')
    			$query.= " AND a.featured != 1";
	
    		if ($params->get('FeaturedItems')=='2')
    			$query.= " AND a.featured = 1";
    			
    		$query .= $where . ' ORDER BY ' . $orderby;

    		// end K2 specific		
	    } else {
            // start Joomla specific
            
            $catCondition = '';

            if ($show_fp != 2) {
				if ($content_source=='com_categories') {
					if ($catid)
					{
						if (is_array($catid)) {
							$jcids = implode($catid,',');	
							$ids = explode( ',', $jcids );
						} else {
							$ids = explode( ',', $catid );
						}
						
						JArrayHelper::toInteger( $ids );
						$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
					}
				}
        	}
		
    		// Content Items only
    		$query = 'SELECT a.*, ' .
    			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
    			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
    			' FROM #__content AS a' .
    			($show_fp == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
    			($show_fp == '2' ? ' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
    			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
    			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
    			' WHERE a.state = 1'. $where .' AND s.id > 0' .
    			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
    			($catid && $show_fp != 2 ? $catCondition : '').
    			($secid && $show_fp != 2 ? $secCondition : '').
    			($show_fp == '0' ? ' AND f.content_id IS NULL ' : '').
    			' AND s.published = 1' .
    			' AND cc.published = 1' .
    			' ORDER BY '. $orderby;
    		// end Joomla specific
		}	
		
			
		$db->setQuery($query, 0, $count);

		$rows = $db->loadObjectList();

        $i=0;
		$lists	= array();
		
		if (is_array($rows) && count($rows)>0) {
    		foreach ( $rows as $row )
    		{
    		    //process content plugins
    		    $text = JHTML::_('content.prepare',$row->introtext,$cparams);
    			$lists[$i]->id = $row->id;
    			$lists[$i]->created = $row->created;
    			$lists[$i]->modified = $row->modified;
    			$lists[$i]->title = modSlideShowSP2Helper::prepareTitle($row->title, $params);
    			$lists[$i]->introtext = modSlideShowSP2Helper::prepareContent($text, $params);

    			if ($content_source=='k2_categories') {
    			    $lists[$i]->link = JRoute::_(K2HelperRoute::getItemRoute($row->id.':'.$row->alias, $row->catid.':'.$row->categoryalias));
    			    $images = modSlideShowSP2Helper::getK2Images($row->id,$imgSource);				
    			} else {
    			    $lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
    			    $images = modSlideShowSP2Helper::getImages($row->introtext);
    			}
			
    			$lists[$i]->image = $images->image;
    			$i++;
    		}
        }
		return $lists;
	}
	
	function prepareTitle($text, &$params) {
		$text=htmlspecialchars($text);
		// Title limit
		$titlelimit=$params->get('titlelimit',20);
		switch ($params->get('titleas')) {
			case 0 :
				$text = explode(' ',$text);
				$sep = (count($text)>$titlelimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$titlelimit)) . $sep;
				break;
			case 1 :
				$sep = (strlen($text)>$titlelimit) ? '...' : '';
				$text=substr($text,0,$titlelimit) . $sep;
				break;
			case 2 :
				$text = $text;
				break;
			default :
				$text = explode(' ',$text);
				$sep = (count($text)>$titlelimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$titlelimit)) . $sep;
				break;				
		}		
		
		return $text;
	}	
	
	function prepareContent($text, &$params) {
		
		$text = JFilterOutPut::cleanText($text);

	    // Description limit
		$desclimit=$params->get('desclimit',30);
		switch ($params->get('desclimitas')) {
			case 0 :
				$text = explode(' ',$text);
				$sep = (count($text)>$desclimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$desclimit)) . $sep;
				break;
			case 1 :
				$sep = (strlen($text)>$desclimit) ? '...' : '';
				$text=substr($text,0,$desclimit) . $sep;
				break;
			case 2 :
				$text = $text;
				break;
			default :
				$text = explode(' ',$text);
				$sep = (count($text)>$desclimit) ? '...' : '';
				$text=implode(' ', array_slice($text,0,$desclimit)) . $sep;
				break;
		}		
		
		return $text;
	}

	function getK2Images($id,$imgSource) {	  
		
		$images = new stdClass();
		$images->image = false;
		
		if (file_exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$id).'_' . $imgSource . '.jpg')) {
		    $imgsrc = 'media/k2/items/cache/'.md5("Image".$id).'_' . $imgSource . '.jpg';
		}
		
		$images->image = $imgsrc;
		 
		return $images;
	}	
	
	function getImages($src) {	  
		
		preg_match("/\<img.+?src=\"(.+?)\".+?\/>/", $src, $matches);
		
		$images = new stdClass();
		$images->image = false;

		$paths = array();
		
		//If no image found
		if (!isset($matches[1])) { 
			$matches[1]='modules/mod_freeslider_sp1/assets/images/no-image.jpg';
		}
		
		 if (!file_exists($matches[1])) {
			$matches[1]='modules/mod_freeslider_sp1/assets/images/no-image.jpg';
		 }		
		
		if (isset($matches[1])) {
			$image_path = $matches[1];
			
			// remove any / that begins the path
			if (substr($image_path, 0 , 1) == '/') $image_path = substr($image_path, 1);
				
			$images->image = $image_path;
		} 
		return $images;
	}
	
}
 